maint.mk: test further PATH_MAX issues
[gnulib.git] / top / maint.mk
1 # -*-Makefile-*-
2 # This Makefile fragment tries to be general-purpose enough to be
3 # used by many projects via the gnulib maintainer-makefile module.
4
5 ## Copyright (C) 2001-2011 Free Software Foundation, Inc.
6 ##
7 ## This program is free software: you can redistribute it and/or modify
8 ## it under the terms of the GNU General Public License as published by
9 ## the Free Software Foundation, either version 3 of the License, or
10 ## (at your option) any later version.
11 ##
12 ## This program is distributed in the hope that it will be useful,
13 ## but WITHOUT ANY WARRANTY; without even the implied warranty of
14 ## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
15 ## GNU General Public License for more details.
16 ##
17 ## You should have received a copy of the GNU General Public License
18 ## along with this program.  If not, see <http://www.gnu.org/licenses/>.
19
20 # This is reported not to work with make-3.79.1
21 # ME := $(word $(words $(MAKEFILE_LIST)),$(MAKEFILE_LIST))
22 ME := maint.mk
23
24 # Override this in cfg.mk if you use a non-standard build-aux directory.
25 build_aux ?= $(srcdir)/build-aux
26
27 # Do not save the original name or timestamp in the .tar.gz file.
28 # Use --rsyncable if available.
29 gzip_rsyncable := \
30   $(shell gzip --help 2>/dev/null|grep rsyncable >/dev/null \
31     && printf %s --rsyncable)
32 GZIP_ENV = '--no-name --best $(gzip_rsyncable)'
33
34 GIT = git
35 VC = $(GIT)
36
37 VC_LIST = $(build_aux)/vc-list-files -C $(srcdir)
38
39 # You can override this variable in cfg.mk to set your own regexp
40 # matching files to ignore.
41 VC_LIST_ALWAYS_EXCLUDE_REGEX ?= ^$$
42
43 # This is to preprocess robustly the output of $(VC_LIST), so that even
44 # when $(srcdir) is a pathological name like "....", the leading sed command
45 # removes only the intended prefix.
46 _dot_escaped_srcdir = $(subst .,\.,$(srcdir))
47
48 # Post-process $(VC_LIST) output, prepending $(srcdir)/, but only
49 # when $(srcdir) is not ".".
50 ifeq ($(srcdir),.)
51 _prepend_srcdir_prefix =
52 else
53 _prepend_srcdir_prefix = | sed 's|^|$(srcdir)/|'
54 endif
55
56 # In order to be able to consistently filter "."-relative names,
57 # (i.e., with no $(srcdir) prefix), this definition is careful to
58 # remove any $(srcdir) prefix, and to restore what it removes.
59 _sc_excl = \
60   $(if $(exclude_file_name_regexp--$@),$(exclude_file_name_regexp--$@),^$$)
61 VC_LIST_EXCEPT = \
62   $(VC_LIST) | sed 's|^$(_dot_escaped_srcdir)/||' \
63         | if test -f $(srcdir)/.x-$@; then grep -vEf $(srcdir)/.x-$@; \
64           else grep -Ev -e "$${VC_LIST_EXCEPT_DEFAULT-ChangeLog}"; fi \
65         | grep -Ev -e '($(VC_LIST_ALWAYS_EXCLUDE_REGEX)|$(_sc_excl))' \
66         $(_prepend_srcdir_prefix)
67
68 ifeq ($(origin prev_version_file), undefined)
69   prev_version_file = $(srcdir)/.prev-version
70 endif
71
72 PREV_VERSION := $(shell cat $(prev_version_file) 2>/dev/null)
73 VERSION_REGEXP = $(subst .,\.,$(VERSION))
74 PREV_VERSION_REGEXP = $(subst .,\.,$(PREV_VERSION))
75
76 ifeq ($(VC),$(GIT))
77 this-vc-tag = v$(VERSION)
78 this-vc-tag-regexp = v$(VERSION_REGEXP)
79 else
80 tag-package = $(shell echo "$(PACKAGE)" | tr '[:lower:]' '[:upper:]')
81 tag-this-version = $(subst .,_,$(VERSION))
82 this-vc-tag = $(tag-package)-$(tag-this-version)
83 this-vc-tag-regexp = $(this-vc-tag)
84 endif
85 my_distdir = $(PACKAGE)-$(VERSION)
86
87 # Old releases are stored here.
88 release_archive_dir ?= ../release
89
90 # Override gnu_rel_host and url_dir_list in cfg.mk if these are not right.
91 # Use alpha.gnu.org for alpha and beta releases.
92 # Use ftp.gnu.org for stable releases.
93 gnu_ftp_host-alpha = alpha.gnu.org
94 gnu_ftp_host-beta = alpha.gnu.org
95 gnu_ftp_host-stable = ftp.gnu.org
96 gnu_rel_host ?= $(gnu_ftp_host-$(RELEASE_TYPE))
97
98 ifeq ($(gnu_rel_host),ftp.gnu.org)
99 url_dir_list ?= http://ftpmirror.gnu.org/$(PACKAGE)
100 else
101 url_dir_list ?= ftp://$(gnu_rel_host)/gnu/$(PACKAGE)
102 endif
103
104 # Override this in cfg.mk if you are using a different format in your
105 # NEWS file.
106 today = $(shell date +%Y-%m-%d)
107
108 # Select which lines of NEWS are searched for $(news-check-regexp).
109 # This is a sed line number spec.  The default says that we search
110 # lines 1..10 of NEWS for $(news-check-regexp).
111 # If you want to search only line 3 or only lines 20-22, use "3" or "20,22".
112 news-check-lines-spec ?= 1,10
113 news-check-regexp ?= '^\*.* $(VERSION_REGEXP) \($(today)\)'
114
115 # Prevent programs like 'sort' from considering distinct strings to be equal.
116 # Doing it here saves us from having to set LC_ALL elsewhere in this file.
117 export LC_ALL = C
118
119 ## --------------- ##
120 ## Sanity checks.  ##
121 ## --------------- ##
122
123 _cfg_mk := $(shell test -f $(srcdir)/cfg.mk && echo '$(srcdir)/cfg.mk')
124
125 # Collect the names of rules starting with `sc_'.
126 syntax-check-rules := $(sort $(shell sed -n 's/^\(sc_[a-zA-Z0-9_-]*\):.*/\1/p' \
127                         $(srcdir)/$(ME) $(_cfg_mk)))
128 .PHONY: $(syntax-check-rules)
129
130 ifeq ($(shell $(VC_LIST) >/dev/null 2>&1; echo $$?),0)
131 local-checks-available += $(syntax-check-rules)
132 else
133 local-checks-available += no-vc-detected
134 no-vc-detected:
135         @echo "No version control files detected; skipping syntax check"
136 endif
137 .PHONY: $(local-checks-available)
138
139 # Arrange to print the name of each syntax-checking rule just before running it.
140 $(syntax-check-rules): %: %.m
141 sc_m_rules_ = $(patsubst %, %.m, $(syntax-check-rules))
142 .PHONY: $(sc_m_rules_)
143 $(sc_m_rules_):
144         @echo $(patsubst sc_%.m, %, $@)
145         @date +%s.%N > .sc-start-$(basename $@)
146
147 # Compute and print the elapsed time for each syntax-check rule.
148 sc_z_rules_ = $(patsubst %, %.z, $(syntax-check-rules))
149 .PHONY: $(sc_z_rules_)
150 $(sc_z_rules_): %.z: %
151         @end=$$(date +%s.%N);                                           \
152         start=$$(cat .sc-start-$*);                                     \
153         rm -f .sc-start-$*;                                             \
154         awk -v s=$$start -v e=$$end                                     \
155           'END {printf "%.2f $(patsubst sc_%,%,$*)\n", e - s}' < /dev/null
156
157 # The patsubst here is to replace each sc_% rule with its sc_%.z wrapper
158 # that computes and prints elapsed time.
159 local-check :=                                                          \
160   $(patsubst sc_%, sc_%.z,                                              \
161     $(filter-out $(local-checks-to-skip), $(local-checks-available)))
162
163 syntax-check: $(local-check)
164
165 # _sc_search_regexp
166 #
167 # This macro searches for a given construct in the selected files and
168 # then takes some action.
169 #
170 # Parameters (shell variables):
171 #
172 #  prohibit | require
173 #
174 #     Regular expression (ERE) denoting either a forbidden construct
175 #     or a required construct.  Those arguments are exclusive.
176 #
177 #  in_vc_files | in_files
178 #
179 #     grep-E-style regexp denoting the files to check.  If no files
180 #     are specified the default are all the files that are under
181 #     version control.
182 #
183 #  containing | non_containing
184 #
185 #     Select the files (non) containing strings matching this regexp.
186 #     If both arguments are specified then CONTAINING takes
187 #     precedence.
188 #
189 #  with_grep_options
190 #
191 #     Extra options for grep.
192 #
193 #  ignore_case
194 #
195 #     Ignore case.
196 #
197 #  halt
198 #
199 #     Message to display before to halting execution.
200 #
201 # Finally, you may exempt files based on an ERE matching file names.
202 # For example, to exempt from the sc_space_tab check all files with the
203 # .diff suffix, set this Make variable:
204 #
205 # exclude_file_name_regexp--sc_space_tab = \.diff$
206 #
207 # Note that while this functionality is mostly inherited via VC_LIST_EXCEPT,
208 # when filtering by name via in_files, we explicitly filter out matching
209 # names here as well.
210
211 # By default, _sc_search_regexp does not ignore case.
212 export ignore_case =
213 _ignore_case = $$(test -n "$$ignore_case" && printf %s -i || :)
214
215 define _sc_say_and_exit
216    dummy=; : so we do not need a semicolon before each use;             \
217    { printf '%s\n' "$(ME): $$msg" 1>&2; exit 1; };
218 endef
219
220 # _sc_search_regexp used to be named _prohibit_regexp.  However,
221 # upgrading to the new definition and leaving the old name undefined
222 # would usually convert each custom rule using $(_prohibit_regexp)
223 # (usually defined in cfg.mk) into a no-op.  This definition ensures
224 # that people know right away if they're still using the old name.
225 # FIXME: remove in 2012.
226 _prohibit_regexp = \
227   $(error '*** you need to s/_prohibit_regexp/_sc_search_regexp/, and adapt')
228
229 define _sc_search_regexp
230    dummy=; : so we do not need a semicolon before each use;             \
231                                                                         \
232    : Check arguments;                                                   \
233    test -n "$$prohibit" && test -n "$$require"                          \
234      && { msg='Cannot specify both prohibit and require'                \
235           $(_sc_say_and_exit) } || :;                                   \
236    test -z "$$prohibit" && test -z "$$require"                          \
237      && { msg='Should specify either prohibit or require'               \
238           $(_sc_say_and_exit) } || :;                                   \
239    test -n "$$in_vc_files" && test -n "$$in_files"                      \
240      && { msg='Cannot specify both in_vc_files and in_files'            \
241           $(_sc_say_and_exit) } || :;                                   \
242    test "x$$halt" != x                                                  \
243      || { msg='halt not defined' $(_sc_say_and_exit) };                 \
244                                                                         \
245    : Filter by file name;                                               \
246    if test -n "$$in_files"; then                                        \
247      files=$$(find $(srcdir) | grep -E "$$in_files"                     \
248               | grep -Ev '$(exclude_file_name_regexp--$@)');            \
249    else                                                                 \
250      files=$$($(VC_LIST_EXCEPT));                                       \
251      if test -n "$$in_vc_files"; then                                   \
252        files=$$(echo "$$files" | grep -E "$$in_vc_files");              \
253      fi;                                                                \
254    fi;                                                                  \
255                                                                         \
256    : Filter by content;                                                 \
257    test -n "$$files" && test -n "$$containing"                          \
258      && { files=$$(grep -l "$$containing" $$files); } || :;             \
259    test -n "$$files" && test -n "$$non_containing"                      \
260      && { files=$$(grep -vl "$$non_containing" $$files); } || :;        \
261                                                                         \
262    : Check for the construct;                                           \
263    if test -n "$$files"; then                                           \
264      if test -n "$$prohibit"; then                                      \
265        grep $$with_grep_options $(_ignore_case) -nE "$$prohibit" $$files \
266          && { msg="$$halt" $(_sc_say_and_exit) } || :;                  \
267      else                                                               \
268        grep $$with_grep_options $(_ignore_case) -LE "$$require" $$files \
269            | grep .                                                     \
270          && { msg="$$halt" $(_sc_say_and_exit) } || :;                  \
271      fi                                                                 \
272    else :;                                                              \
273    fi || :;
274 endef
275
276 sc_avoid_if_before_free:
277         @$(build_aux)/useless-if-before-free                            \
278                 $(useless_free_options)                                 \
279             $$($(VC_LIST_EXCEPT) | grep -v useless-if-before-free) &&   \
280           { echo '$(ME): found useless "if" before "free" above' 1>&2;  \
281             exit 1; } || :
282
283 sc_cast_of_argument_to_free:
284         @prohibit='\<free *\( *\(' halt='don'\''t cast free argument'   \
285           $(_sc_search_regexp)
286
287 sc_cast_of_x_alloc_return_value:
288         @prohibit='\*\) *x(m|c|re)alloc\>'                              \
289         halt='don'\''t cast x*alloc return value'                       \
290           $(_sc_search_regexp)
291
292 sc_cast_of_alloca_return_value:
293         @prohibit='\*\) *alloca\>'                                      \
294         halt='don'\''t cast alloca return value'                        \
295           $(_sc_search_regexp)
296
297 sc_space_tab:
298         @prohibit='[ ]  '                                               \
299         halt='found SPACE-TAB sequence; remove the SPACE'               \
300           $(_sc_search_regexp)
301
302 # Don't use *scanf or the old ato* functions in `real' code.
303 # They provide no error checking mechanism.
304 # Instead, use strto* functions.
305 sc_prohibit_atoi_atof:
306         @prohibit='\<([fs]?scanf|ato([filq]|ll)) *\('                           \
307         halt='do not use *scan''f, ato''f, ato''i, ato''l, ato''ll or ato''q'   \
308           $(_sc_search_regexp)
309
310 # Use STREQ rather than comparing strcmp == 0, or != 0.
311 sc_prohibit_strcmp:
312         @grep -nE '! *str''cmp *\(|\<str''cmp *\(.+\) *[!=]='   \
313             $$($(VC_LIST_EXCEPT))                                       \
314           | grep -vE ':# *define STRN?EQ\(' &&                          \
315           { echo '$(ME): replace str''cmp calls above with STREQ/STRNEQ' \
316                 1>&2; exit 1; } || :
317
318 # Pass EXIT_*, not number, to usage, exit, and error (when exiting)
319 # Convert all uses automatically, via these two commands:
320 # git grep -l '\<exit *(1)' \
321 #  | grep -vEf .x-sc_prohibit_magic_number_exit \
322 #  | xargs --no-run-if-empty \
323 #      perl -pi -e 's/(^|[^.])\b(exit ?)\(1\)/$1$2(EXIT_FAILURE)/'
324 # git grep -l '\<exit *(0)' \
325 #  | grep -vEf .x-sc_prohibit_magic_number_exit \
326 #  | xargs --no-run-if-empty \
327 #      perl -pi -e 's/(^|[^.])\b(exit ?)\(0\)/$1$2(EXIT_SUCCESS)/'
328 sc_prohibit_magic_number_exit:
329         @prohibit='(^|[^.])\<(usage|exit) ?\([0-9]|\<error ?\([1-9][0-9]*,'     \
330         halt='use EXIT_* values rather than magic number'                       \
331           $(_sc_search_regexp)
332
333 # Using EXIT_SUCCESS as the first argument to error is misleading,
334 # since when that parameter is 0, error does not exit.  Use `0' instead.
335 sc_error_exit_success:
336         @prohibit='error *\(EXIT_SUCCESS,'                              \
337         in_vc_files='\.[chly]$$'                                        \
338         halt='found error (EXIT_SUCCESS'                                \
339          $(_sc_search_regexp)
340
341 # `FATAL:' should be fully upper-cased in error messages
342 # `WARNING:' should be fully upper-cased, or fully lower-cased
343 sc_error_message_warn_fatal:
344         @grep -nEA2 '[^rp]error *\(' $$($(VC_LIST_EXCEPT))              \
345             | grep -E '"Warning|"Fatal|"fatal' &&                       \
346           { echo '$(ME): use FATAL, WARNING or warning' 1>&2;           \
347             exit 1; } || :
348
349 # Error messages should not start with a capital letter
350 sc_error_message_uppercase:
351         @grep -nEA2 '[^rp]error *\(' $$($(VC_LIST_EXCEPT))              \
352             | grep -E '"[A-Z]'                                          \
353             | grep -vE '"FATAL|"WARNING|"Java|"C#|PRIuMAX' &&           \
354           { echo '$(ME): found capitalized error message' 1>&2;         \
355             exit 1; } || :
356
357 # Error messages should not end with a period
358 sc_error_message_period:
359         @grep -nEA2 '[^rp]error *\(' $$($(VC_LIST_EXCEPT))              \
360             | grep -E '[^."]\."' &&                                     \
361           { echo '$(ME): found error message ending in period' 1>&2;    \
362             exit 1; } || :
363
364 sc_file_system:
365         @prohibit=file''system                                          \
366         ignore_case=1                                                   \
367         halt='found use of "file''system"; spell it "file system"'      \
368           $(_sc_search_regexp)
369
370 # Don't use cpp tests of this symbol.  All code assumes config.h is included.
371 sc_prohibit_have_config_h:
372         @prohibit='^# *if.*HAVE''_CONFIG_H'                             \
373         halt='found use of HAVE''_CONFIG_H; remove'                     \
374           $(_sc_search_regexp)
375
376 # Nearly all .c files must include <config.h>.  However, we also permit this
377 # via inclusion of a package-specific header, if cfg.mk specified one.
378 # config_h_header must be suitable for grep -E.
379 config_h_header ?= <config\.h>
380 sc_require_config_h:
381         @require='^# *include $(config_h_header)'                       \
382         in_vc_files='\.c$$'                                             \
383         halt='the above files do not include <config.h>'                \
384           $(_sc_search_regexp)
385
386 # You must include <config.h> before including any other header file.
387 # This can possibly be via a package-specific header, if given by cfg.mk.
388 sc_require_config_h_first:
389         @if $(VC_LIST_EXCEPT) | grep -l '\.c$$' > /dev/null; then       \
390           fail=0;                                                       \
391           for i in $$($(VC_LIST_EXCEPT) | grep '\.c$$'); do             \
392             grep '^# *include\>' $$i | sed 1q                           \
393                 | grep -E '^# *include $(config_h_header)' > /dev/null  \
394               || { echo $$i; fail=1; };                                 \
395           done;                                                         \
396           test $$fail = 1 &&                                            \
397             { echo '$(ME): the above files include some other header'   \
398                 'before <config.h>' 1>&2; exit 1; } || :;               \
399         else :;                                                         \
400         fi
401
402 sc_prohibit_HAVE_MBRTOWC:
403         @prohibit='\bHAVE_MBRTOWC\b'                                    \
404         halt="do not use $$prohibit; it is always defined"              \
405           $(_sc_search_regexp)
406
407 # To use this "command" macro, you must first define two shell variables:
408 # h: the header, enclosed in <> or ""
409 # re: a regular expression that matches IFF something provided by $h is used.
410 define _sc_header_without_use
411   dummy=; : so we do not need a semicolon before each use;              \
412   h_esc=`echo "$$h"|sed 's/\./\\\\./g'`;                                \
413   if $(VC_LIST_EXCEPT) | grep -l '\.c$$' > /dev/null; then              \
414     files=$$(grep -l '^# *include '"$$h_esc"                            \
415              $$($(VC_LIST_EXCEPT) | grep '\.c$$')) &&                   \
416     grep -LE "$$re" $$files | grep . &&                                 \
417       { echo "$(ME): the above files include $$h but don't use it"      \
418         1>&2; exit 1; } || :;                                           \
419   else :;                                                               \
420   fi
421 endef
422
423 # Prohibit the inclusion of assert.h without an actual use of assert.
424 sc_prohibit_assert_without_use:
425         @h='<assert.h>' re='\<assert *\(' $(_sc_header_without_use)
426
427 # Prohibit the inclusion of close-stream.h without an actual use.
428 sc_prohibit_close_stream_without_use:
429         @h='"close-stream.h"' re='\<close_stream *\(' $(_sc_header_without_use)
430
431 # Prohibit the inclusion of getopt.h without an actual use.
432 sc_prohibit_getopt_without_use:
433         @h='<getopt.h>' re='\<getopt(_long)? *\(' $(_sc_header_without_use)
434
435 # Don't include quotearg.h unless you use one of its functions.
436 sc_prohibit_quotearg_without_use:
437         @h='"quotearg.h"' re='\<quotearg(_[^ ]+)? *\(' $(_sc_header_without_use)
438
439 # Don't include quote.h unless you use one of its functions.
440 sc_prohibit_quote_without_use:
441         @h='"quote.h"' re='\<quote(_n)? *\(' $(_sc_header_without_use)
442
443 # Don't include this header unless you use one of its functions.
444 sc_prohibit_long_options_without_use:
445         @h='"long-options.h"' re='\<parse_long_options *\(' \
446           $(_sc_header_without_use)
447
448 # Don't include this header unless you use one of its functions.
449 sc_prohibit_inttostr_without_use:
450         @h='"inttostr.h"' re='\<(off|[iu]max|uint)tostr *\(' \
451           $(_sc_header_without_use)
452
453 # Don't include this header unless you use one of its functions.
454 sc_prohibit_ignore_value_without_use:
455         @h='"ignore-value.h"' re='\<ignore_(value|ptr) *\(' \
456           $(_sc_header_without_use)
457
458 # Don't include this header unless you use one of its functions.
459 sc_prohibit_error_without_use:
460         @h='"error.h"' \
461         re='\<error(_at_line|_print_progname|_one_per_line|_message_count)? *\('\
462           $(_sc_header_without_use)
463
464 # Don't include xalloc.h unless you use one of its functions.
465 # Consider these symbols:
466 # perl -lne '/^# *define (\w+)\(/ and print $1' lib/xalloc.h|grep -v '^__';
467 # perl -lne '/^(?:extern )?(?:void|char) \*?(\w+) *\(/ and print $1' lib/xalloc.h
468 # Divide into two sets on case, and filter each through this:
469 # | sort | perl -MRegexp::Assemble -le \
470 #  'print Regexp::Assemble->new(file => "/dev/stdin")->as_string'|sed 's/\?://g'
471 # Note this was produced by the above:
472 # _xa1 = \
473 #x(((2n?)?re|c(har)?|n(re|m)|z)alloc|alloc_(oversized|die)|m(alloc|emdup)|strdup)
474 # But we can do better, in at least two ways:
475 # 1) take advantage of two "dup"-suffixed strings:
476 # x(((2n?)?re|c(har)?|n(re|m)|[mz])alloc|alloc_(oversized|die)|(mem|str)dup)
477 # 2) notice that "c(har)?|[mz]" is equivalent to the shorter and more readable
478 # "char|[cmz]"
479 # x(((2n?)?re|char|n(re|m)|[cmz])alloc|alloc_(oversized|die)|(mem|str)dup)
480 _xa1 = x(((2n?)?re|char|n(re|m)|[cmz])alloc|alloc_(oversized|die)|(mem|str)dup)
481 _xa2 = X([CZ]|N?M)ALLOC
482 sc_prohibit_xalloc_without_use:
483         @h='"xalloc.h"' \
484         re='\<($(_xa1)|$(_xa2)) *\('\
485           $(_sc_header_without_use)
486
487 # Extract function names:
488 # perl -lne '/^(?:extern )?(?:void|char) \*?(\w+) *\(/ and print $1' lib/hash.h
489 _hash_re = \
490 clear|delete|free|get_(first|next)|insert|lookup|print_statistics|reset_tuning
491 _hash_fn = \<($(_hash_re)) *\(
492 _hash_struct = (struct )?\<[Hh]ash_(table|tuning)\>
493 sc_prohibit_hash_without_use:
494         @h='"hash.h"' \
495         re='$(_hash_fn)|$(_hash_struct)'\
496           $(_sc_header_without_use)
497
498 sc_prohibit_cloexec_without_use:
499         @h='"cloexec.h"' re='\<(set_cloexec_flag|dup_cloexec) *\(' \
500           $(_sc_header_without_use)
501
502 sc_prohibit_posixver_without_use:
503         @h='"posixver.h"' re='\<posix2_version *\(' $(_sc_header_without_use)
504
505 sc_prohibit_same_without_use:
506         @h='"same.h"' re='\<same_name *\(' $(_sc_header_without_use)
507
508 sc_prohibit_hash_pjw_without_use:
509         @h='"hash-pjw.h"' \
510         re='\<hash_pjw *\(' \
511           $(_sc_header_without_use)
512
513 sc_prohibit_safe_read_without_use:
514         @h='"safe-read.h"' re='(\<SAFE_READ_ERROR\>|\<safe_read *\()' \
515           $(_sc_header_without_use)
516
517 sc_prohibit_argmatch_without_use:
518         @h='"argmatch.h"' \
519         re='(\<(ARRAY_CARDINALITY|X?ARGMATCH(|_TO_ARGUMENT|_VERIFY))\>|\<argmatch(_exit_fn|_(in)?valid) *\()' \
520           $(_sc_header_without_use)
521
522 sc_prohibit_canonicalize_without_use:
523         @h='"canonicalize.h"' \
524         re='CAN_(EXISTING|ALL_BUT_LAST|MISSING)|canonicalize_(mode_t|filename_mode)' \
525           $(_sc_header_without_use)
526
527 sc_prohibit_root_dev_ino_without_use:
528         @h='"root-dev-ino.h"' \
529         re='(\<ROOT_DEV_INO_(CHECK|WARN)\>|\<get_root_dev_ino *\()' \
530           $(_sc_header_without_use)
531
532 sc_prohibit_openat_without_use:
533         @h='"openat.h"' \
534         re='\<(openat_(permissive|needs_fchdir|(save|restore)_fail)|l?(stat|ch(own|mod))at|(euid)?accessat)\>' \
535           $(_sc_header_without_use)
536
537 # Prohibit the inclusion of c-ctype.h without an actual use.
538 ctype_re = isalnum|isalpha|isascii|isblank|iscntrl|isdigit|isgraph|islower\
539 |isprint|ispunct|isspace|isupper|isxdigit|tolower|toupper
540 sc_prohibit_c_ctype_without_use:
541         @h='[<"]c-ctype.h[">]' re='\<c_($(ctype_re)) *\(' \
542           $(_sc_header_without_use)
543
544 _empty =
545 _sp = $(_empty) $(_empty)
546 # The following list was generated by running:
547 # man signal.h|col -b|perl -ne '/bsd_signal.*;/.../sigwaitinfo.*;/ and print' \
548 #   | perl -lne '/^\s+(?:int|void).*?(\w+).*/ and print $1' | fmt
549 _sig_functions = \
550   bsd_signal kill killpg pthread_kill pthread_sigmask raise sigaction \
551   sigaddset sigaltstack sigdelset sigemptyset sigfillset sighold sigignore \
552   siginterrupt sigismember signal sigpause sigpending sigprocmask sigqueue \
553   sigrelse sigset sigsuspend sigtimedwait sigwait sigwaitinfo
554 _sig_function_re = $(subst $(_sp),|,$(strip $(_sig_functions)))
555 # The following were extracted from "man signal.h" manually.
556 _sig_types_and_consts =                                                 \
557   MINSIGSTKSZ SA_NOCLDSTOP SA_NOCLDWAIT SA_NODEFER SA_ONSTACK           \
558   SA_RESETHAND SA_RESTART SA_SIGINFO SIGEV_NONE SIGEV_SIGNAL            \
559   SIGEV_THREAD SIGSTKSZ SIG_BLOCK SIG_SETMASK SIG_UNBLOCK SS_DISABLE    \
560   SS_ONSTACK mcontext_t pid_t sig_atomic_t sigevent siginfo_t sigset_t  \
561   sigstack sigval stack_t ucontext_t
562 # generated via this:
563 # perl -lne '/^#ifdef (SIG\w+)/ and print $1' lib/sig2str.c|sort -u|fmt -70
564 _sig_names =                                                            \
565   SIGABRT SIGALRM SIGALRM1 SIGBUS SIGCANCEL SIGCHLD SIGCLD SIGCONT      \
566   SIGDANGER SIGDIL SIGEMT SIGFPE SIGFREEZE SIGGRANT SIGHUP SIGILL       \
567   SIGINFO SIGINT SIGIO SIGIOT SIGKAP SIGKILL SIGKILLTHR SIGLOST SIGLWP  \
568   SIGMIGRATE SIGMSG SIGPHONE SIGPIPE SIGPOLL SIGPRE SIGPROF SIGPWR      \
569   SIGQUIT SIGRETRACT SIGSAK SIGSEGV SIGSOUND SIGSTKFLT SIGSTOP SIGSYS   \
570   SIGTERM SIGTHAW SIGTRAP SIGTSTP SIGTTIN SIGTTOU SIGURG SIGUSR1        \
571   SIGUSR2 SIGVIRT SIGVTALRM SIGWAITING SIGWINCH SIGWIND SIGWINDOW       \
572   SIGXCPU SIGXFSZ
573 _sig_syms_re = $(subst $(_sp),|,$(strip $(_sig_names) $(_sig_types_and_consts)))
574
575 # Prohibit the inclusion of signal.h without an actual use.
576 sc_prohibit_signal_without_use:
577         @h='<signal.h>'                                                 \
578         re='\<($(_sig_function_re)) *\(|\<($(_sig_syms_re))\>'          \
579           $(_sc_header_without_use)
580
581 # Don't include stdio--.h unless you use one of its functions.
582 sc_prohibit_stdio--_without_use:
583         @h='"stdio--.h"' re='\<((f(re)?|p)open|tmpfile) *\('    \
584           $(_sc_header_without_use)
585
586 # Don't include stdio-safer.h unless you use one of its functions.
587 sc_prohibit_stdio-safer_without_use:
588         @h='"stdio-safer.h"' re='\<((f(re)?|p)open|tmpfile)_safer *\('  \
589           $(_sc_header_without_use)
590
591 # Prohibit the inclusion of strings.h without a sensible use.
592 # Using the likes of bcmp, bcopy, bzero, index or rindex is not sensible.
593 sc_prohibit_strings_without_use:
594         @h='<strings.h>'                                                \
595         re='\<(strn?casecmp|ffs(ll)?)\>'                                \
596           $(_sc_header_without_use)
597
598 # Get the list of symbol names with this:
599 # perl -lne '/^# *define (\w+)\(/ and print $1' lib/intprops.h|grep -v '^s'|fmt
600 _intprops_names =                                                       \
601   TYPE_IS_INTEGER TYPE_TWOS_COMPLEMENT TYPE_ONES_COMPLEMENT             \
602   TYPE_SIGNED_MAGNITUDE TYPE_SIGNED TYPE_MINIMUM TYPE_MAXIMUM           \
603   INT_STRLEN_BOUND INT_BUFSIZE_BOUND
604 _intprops_syms_re = $(subst $(_sp),|,$(strip $(_intprops_names)))
605 # Prohibit the inclusion of intprops.h without an actual use.
606 sc_prohibit_intprops_without_use:
607         @h='"intprops.h"'                                               \
608         re='\<($(_intprops_syms_re)) *\('                               \
609           $(_sc_header_without_use)
610
611 _stddef_syms_re = NULL|offsetof|ptrdiff_t|size_t|wchar_t
612 # Prohibit the inclusion of stddef.h without an actual use.
613 sc_prohibit_stddef_without_use:
614         @h='<stddef.h>'                                                 \
615         re='\<($(_stddef_syms_re)) *\('                                 \
616           $(_sc_header_without_use)
617
618 # Don't include xfreopen.h unless you use one of its functions.
619 sc_prohibit_xfreopen_without_use:
620         @h='"xfreopen.h"' re='\<xfreopen *\(' $(_sc_header_without_use)
621
622 sc_obsolete_symbols:
623         @prohibit='\<(HAVE''_FCNTL_H|O''_NDELAY)\>'                     \
624         halt='do not use HAVE''_FCNTL_H or O'_NDELAY                    \
625           $(_sc_search_regexp)
626
627 # FIXME: warn about definitions of EXIT_FAILURE, EXIT_SUCCESS, STREQ
628
629 # Each nonempty ChangeLog line must start with a year number, or a TAB.
630 sc_changelog:
631         @prohibit='^[^12        ]'                                      \
632         in_vc_files='^ChangeLog$$'                                      \
633         halt='found unexpected prefix in a ChangeLog'                   \
634           $(_sc_search_regexp)
635
636 # Ensure that each .c file containing a "main" function also
637 # calls set_program_name.
638 sc_program_name:
639         @require='set_program_name *\(m?argv\[0\]\);'                   \
640         in_vc_files='\.c$$'                                             \
641         containing='\<main *('                                          \
642         halt='the above files do not call set_program_name'             \
643           $(_sc_search_regexp)
644
645 # Ensure that each .c file containing a "main" function also
646 # calls bindtextdomain.
647 sc_bindtextdomain:
648         @require='bindtextdomain *\('                                   \
649         in_vc_files='\.c$$'                                             \
650         containing='\<main *('                                          \
651         halt='the above files do not call bindtextdomain'               \
652           $(_sc_search_regexp)
653
654 # Require that the final line of each test-lib.sh-using test be this one:
655 # Exit $fail
656 # Note: this test requires GNU grep's --label= option.
657 Exit_witness_file ?= tests/test-lib.sh
658 Exit_base := $(notdir $(Exit_witness_file))
659 sc_require_test_exit_idiom:
660         @if test -f $(srcdir)/$(Exit_witness_file); then                \
661           die=0;                                                        \
662           for i in $$(grep -l -F 'srcdir/$(Exit_base)'                  \
663                 $$($(VC_LIST) tests)); do                               \
664             tail -n1 $$i | grep '^Exit .' > /dev/null                   \
665               && : || { die=1; echo $$i; }                              \
666           done;                                                         \
667           test $$die = 1 &&                                             \
668             { echo 1>&2 '$(ME): the final line in each of the above is not:'; \
669               echo 1>&2 'Exit something';                               \
670               exit 1; } || :;                                           \
671         fi
672
673 sc_trailing_blank:
674         @prohibit='[     ]$$'                                           \
675         halt='found trailing blank(s)'                                  \
676           $(_sc_search_regexp)
677
678 # Match lines like the following, but where there is only one space
679 # between the options and the description:
680 #   -D, --all-repeated[=delimit-method]  print all duplicate lines\n
681 longopt_re = --[a-z][0-9A-Za-z-]*(\[?=[0-9A-Za-z-]*\]?)?
682 sc_two_space_separator_in_usage:
683         @prohibit='^   *(-[A-Za-z],)? $(longopt_re) [^ ].*\\$$'         \
684         halt='help2man requires at least two spaces between an option and its description'\
685           $(_sc_search_regexp)
686
687 # A regexp matching function names like "error" that may be used
688 # to emit translatable messages.
689 _gl_translatable_diag_func_re ?= error
690
691 # Look for diagnostics that aren't marked for translation.
692 # This won't find any for which error's format string is on a separate line.
693 sc_unmarked_diagnostics:
694         @grep -nE                                                       \
695             '\<$(_gl_translatable_diag_func_re) *\([^"]*"[^"]*[a-z]{3}' \
696                 $$($(VC_LIST_EXCEPT))                                   \
697           | grep -Ev '(_|ngettext ?)\(' &&                              \
698           { echo '$(ME): found unmarked diagnostic(s)' 1>&2;            \
699             exit 1; } || :
700
701 # Avoid useless parentheses like those in this example:
702 # #if defined (SYMBOL) || defined (SYM2)
703 sc_useless_cpp_parens:
704         @prohibit='^# *if .*defined *\('                                \
705         halt='found useless parentheses in cpp directive'               \
706           $(_sc_search_regexp)
707
708 # List headers for which HAVE_HEADER_H is always true, assuming you are
709 # using the appropriate gnulib module.  CAUTION: for each "unnecessary"
710 # #if HAVE_HEADER_H that you remove, be sure that your project explicitly
711 # requires the gnulib module that guarantees the usability of that header.
712 gl_assured_headers_ = \
713   cd $(gnulib_dir)/lib && echo *.in.h|sed 's/\.in\.h//g'
714
715 # Convert the list of names to upper case, and replace each space with "|".
716 az_ = abcdefghijklmnopqrstuvwxyz
717 AZ_ = ABCDEFGHIJKLMNOPQRSTUVWXYZ
718 gl_header_upper_case_or_ =                                              \
719   $$($(gl_assured_headers_)                                             \
720     | tr $(az_)/.- $(AZ_)___                                            \
721     | tr -s ' ' '|'                                                     \
722     )
723 sc_prohibit_always_true_header_tests:
724         @or=$(gl_header_upper_case_or_);                                \
725         re="HAVE_($$or)_H";                                             \
726         prohibit='\<'"$$re"'\>'                                         \
727         halt=$$(printf '%s\n'                                           \
728         'do not test the above HAVE_<header>_H symbol(s);'              \
729         '  with the corresponding gnulib module, they are always true') \
730           $(_sc_search_regexp)
731
732 # ==================================================================
733 gl_other_headers_ ?= \
734   intprops.h    \
735   openat.h      \
736   stat-macros.h
737
738 # Perl -lne code to extract "significant" cpp-defined symbols from a
739 # gnulib header file, eliminating a few common false-positives.
740 gl_extract_significant_defines_ = \
741   /^\# *define ([^_ (][^ (]*)(\s*\(|\s+\w+)/\
742     && $$2 !~ /(?:rpl_|_used_without_)/\
743     && $$1 !~ /^(?:NSIG|ATTRIBUTE_NORETURN)$$/\
744     and print $$1
745
746 # Create a list of regular expressions matching the names
747 # of macros that are guaranteed to be defined by parts of gnulib.
748 define def_sym_regex
749         gen_h=$(gl_generated_headers_);                                 \
750         (cd $(gnulib_dir)/lib;                                          \
751           for f in *.in.h $(gl_other_headers_); do                      \
752             perl -lne '$(gl_extract_significant_defines_)' $$f;         \
753           done;                                                         \
754         ) | sort -u                                                     \
755           | grep -Ev '^ATTRIBUTE_NORETURN'                              \
756           | sed 's/^/^ *# *(define|undef)  */;s/$$/\\>/'
757 endef
758
759 # Don't define macros that we already get from gnulib header files.
760 sc_prohibit_always-defined_macros:
761         @if test -d $(gnulib_dir); then                                 \
762           case $$(echo all: | grep -l -f - Makefile) in Makefile);; *)  \
763             echo '$(ME): skipping $@: you lack GNU grep' 1>&2; exit 0;; \
764           esac;                                                         \
765           $(def_sym_regex) | grep -E -f - $$($(VC_LIST_EXCEPT))         \
766             && { echo '$(ME): define the above via some gnulib .h file' \
767                   1>&2;  exit 1; } || :;                                \
768         fi
769 # ==================================================================
770
771 # Prohibit checked in backup files.
772 sc_prohibit_backup_files:
773         @$(VC_LIST) | grep '~$$' &&                             \
774           { echo '$(ME): found version controlled backup file' 1>&2;    \
775             exit 1; } || :
776
777 # Require the latest GPL.
778 sc_GPL_version:
779         @prohibit='either ''version [^3]'                               \
780         halt='GPL vN, N!=3'                                             \
781           $(_sc_search_regexp)
782
783 # Require the latest GFDL.  Two regexp, since some .texi files end up
784 # line wrapping between 'Free Documentation License,' and 'Version'.
785 _GFDL_regexp = (Free ''Documentation.*Version 1\.[^3]|Version 1\.[^3] or any)
786 sc_GFDL_version:
787         @prohibit='$(_GFDL_regexp)'                                     \
788         halt='GFDL vN, N!=3'                                            \
789           $(_sc_search_regexp)
790
791 # Don't use Texinfo's @acronym{}.
792 # http://lists.gnu.org/archive/html/bug-gnulib/2010-03/msg00321.html
793 texinfo_suffix_re_ ?= \.(txi|texi(nfo)?)$$
794 sc_texinfo_acronym:
795         @prohibit='@acronym\{'                                          \
796         in_vc_files='$(texinfo_suffix_re_)'                             \
797         halt='found use of Texinfo @acronym{}'                          \
798           $(_sc_search_regexp)
799
800 cvs_keywords = \
801   Author|Date|Header|Id|Name|Locker|Log|RCSfile|Revision|Source|State
802
803 sc_prohibit_cvs_keyword:
804         @prohibit='\$$($(cvs_keywords))\$$'                             \
805         halt='do not use CVS keyword expansion'                         \
806           $(_sc_search_regexp)
807
808 # This Perl code is slightly obfuscated.  Not only is each "$" doubled
809 # because it's in a Makefile, but the $$c's are comments;  we cannot
810 # use "#" due to the way the script ends up concatenated onto one line.
811 # It would be much more concise, and would produce better output (including
812 # counts) if written as:
813 #   perl -ln -0777 -e '/\n(\n+)$/ and print "$ARGV: ".length $1' ...
814 # but that would be far less efficient, reading the entire contents
815 # of each file, rather than just the last two bytes of each.
816 # In addition, while the code below detects both blank lines and a missing
817 # newline at EOF, the above detects only the former.
818 #
819 # This is a perl script that is expected to be the single-quoted argument
820 # to a command-line "-le".  The remaining arguments are file names.
821 # Print the name of each file that ends in exactly one newline byte.
822 # I.e., warn if there are blank lines (2 or more newlines), or if the
823 # last byte is not a newline.  However, currently we don't complain
824 # about any file that contains exactly one byte.
825 # Exit nonzero if at least one such file is found, otherwise, exit 0.
826 # Warn about, but otherwise ignore open failure.  Ignore seek/read failure.
827 #
828 # Use this if you want to remove trailing empty lines from selected files:
829 #   perl -pi -0777 -e 's/\n\n+$/\n/' files...
830 #
831 require_exactly_one_NL_at_EOF_ =                                        \
832   foreach my $$f (@ARGV)                                                \
833     {                                                                   \
834       open F, "<", $$f or (warn "failed to open $$f: $$!\n"), next;     \
835       my $$p = sysseek (F, -2, 2);                                      \
836       my $$c = "seek failure probably means file has < 2 bytes; ignore"; \
837       my $$last_two_bytes;                                              \
838       defined $$p and $$p = sysread F, $$last_two_bytes, 2;             \
839       close F;                                                          \
840       $$c = "ignore read failure";                                      \
841       $$p && ($$last_two_bytes eq "\n\n"                                \
842               || substr ($$last_two_bytes,1) ne "\n")                   \
843           and (print $$f), $$fail=1;                                    \
844     }                                                                   \
845   END { exit defined $$fail }
846 sc_prohibit_empty_lines_at_EOF:
847         @perl -le '$(require_exactly_one_NL_at_EOF_)' $$($(VC_LIST_EXCEPT)) \
848           || { echo '$(ME): empty line(s) or no newline at EOF'         \
849                 1>&2; exit 1; } || :
850
851 # Make sure we don't use st_blocks.  Use ST_NBLOCKS instead.
852 # This is a bit of a kludge, since it prevents use of the string
853 # even in comments, but for now it does the job with no false positives.
854 sc_prohibit_stat_st_blocks:
855         @prohibit='[.>]st_blocks'                                       \
856         halt='do not use st_blocks; use ST_NBLOCKS'                     \
857           $(_sc_search_regexp)
858
859 # Make sure we don't define any S_IS* macros in src/*.c files.
860 # They're already defined via gnulib's sys/stat.h replacement.
861 sc_prohibit_S_IS_definition:
862         @prohibit='^ *# *define  *S_IS'                                 \
863         halt='do not define S_IS* macros; include <sys/stat.h>'         \
864           $(_sc_search_regexp)
865
866 # Perl block to convert a match to FILE_NAME:LINENO:TEST,
867 # that is shared by two definitions below.
868 perl_filename_lineno_text_ =                                            \
869     -e '  {'                                                            \
870     -e '    $$n = ($$` =~ tr/\n/\n/ + 1);'                              \
871     -e '    ($$v = $$&) =~ s/\n/\\n/g;'                                 \
872     -e '    print "$$ARGV:$$n:$$v\n";'                                  \
873     -e '  }'
874
875 prohibit_doubled_word_RE_ ?= \
876   /\b(then?|[iao]n|i[fst]|but|f?or|at|and|[dt]o)\s+\1\b/gims
877 prohibit_doubled_word_ =                                                \
878     -e 'while ($(prohibit_doubled_word_RE_))'                           \
879     $(perl_filename_lineno_text_)
880
881 # Define this to a regular expression that matches
882 # any filename:dd:match lines you want to ignore.
883 # The default is to ignore no matches.
884 ignore_doubled_word_match_RE_ ?= ^$$
885
886 sc_prohibit_doubled_word:
887         @perl -n -0777 $(prohibit_doubled_word_) $$($(VC_LIST_EXCEPT))  \
888           | grep -vE '$(ignore_doubled_word_match_RE_)'                 \
889           | grep . && { echo '$(ME): doubled words' 1>&2; exit 1; } || :
890
891 # A regular expression matching undesirable combinations of words like
892 # "can not"; this matches them even when the two words appear on different
893 # lines, but not when there is an intervening delimiter like "#" or "*".
894 prohibit_undesirable_word_seq_RE_ ?=                                    \
895   /\bcan\s+not\b/gims
896 prohibit_undesirable_word_seq_ =                                        \
897     -e 'while ($(prohibit_undesirable_word_seq_RE_))'                   \
898     $(perl_filename_lineno_text_)
899 # Define this to a regular expression that matches
900 # any filename:dd:match lines you want to ignore.
901 # The default is to ignore no matches.
902 ignore_undesirable_word_sequence_RE_ ?= ^$$
903
904 sc_prohibit_undesirable_word_seq:
905         @perl -n -0777 $(prohibit_undesirable_word_seq_)                \
906              $$($(VC_LIST_EXCEPT))                                      \
907           | grep -vE '$(ignore_undesirable_word_sequence_RE_)' | grep . \
908           && { echo '$(ME): undesirable word sequence' >&2; exit 1; } || :
909
910 _ptm1 = use "test C1 && test C2", not "test C1 -''a C2"
911 _ptm2 = use "test C1 || test C2", not "test C1 -''o C2"
912 # Using test's -a and -o operators is not portable.
913 # We prefer test over [, since the latter is spelled [[ in configure.ac.
914 sc_prohibit_test_minus_ao:
915         @prohibit='(\<test| \[+) .+ -[ao] '                             \
916         halt='$(_ptm1); $(_ptm2)'                                       \
917           $(_sc_search_regexp)
918
919 # Avoid a test bashism.
920 sc_prohibit_test_double_equal:
921         @prohibit='(\<test| \[+) .+ == '                                \
922         containing='#! */bin/[a-z]*sh'                                  \
923         halt='use "test x = x", not "test x =''= x"'                    \
924           $(_sc_search_regexp)
925
926 # Each program that uses proper_name_utf8 must link with one of the
927 # ICONV libraries.  Otherwise, some ICONV library must appear in LDADD.
928 # The perl -0777 invocation below extracts the possibly-multi-line
929 # definition of LDADD from the appropriate Makefile.am and exits 0
930 # when it contains "ICONV".
931 sc_proper_name_utf8_requires_ICONV:
932         @progs=$$(grep -l 'proper_name_utf8 ''("' $$($(VC_LIST_EXCEPT)));\
933         if test "x$$progs" != x; then                                   \
934           fail=0;                                                       \
935           for p in $$progs; do                                          \
936             dir=$$(dirname "$$p");                                      \
937             perl -0777                                                  \
938               -ne 'exit !(/^LDADD =(.+?[^\\]\n)/ms && $$1 =~ /ICONV/)'  \
939               $$dir/Makefile.am && continue;                            \
940             base=$$(basename "$$p" .c);                                 \
941             grep "$${base}_LDADD.*ICONV)" $$dir/Makefile.am > /dev/null \
942               || { fail=1; echo 1>&2 "$(ME): $$p uses proper_name_utf8"; }; \
943           done;                                                         \
944           test $$fail = 1 &&                                            \
945             { echo 1>&2 '$(ME): the above do not link with any ICONV library'; \
946               exit 1; } || :;                                           \
947         fi
948
949 # Warn about "c0nst struct Foo const foo[]",
950 # but not about "char const *const foo" or "#define const const".
951 sc_redundant_const:
952         @prohibit='\bconst\b[[:space:][:alnum:]]{2,}\bconst\b'          \
953         halt='redundant "const" in declarations'                        \
954           $(_sc_search_regexp)
955
956 sc_const_long_option:
957         @grep '^ *static.*struct option ' $$($(VC_LIST_EXCEPT))         \
958           | grep -Ev 'const struct option|struct option const' && {     \
959               echo 1>&2 '$(ME): add "const" to the above declarations'; \
960               exit 1; } || :
961
962 NEWS_hash =                                                             \
963   $$(sed -n '/^\*.* $(PREV_VERSION_REGEXP) ([0-9-]*)/,$$p'              \
964        $(srcdir)/NEWS                                                   \
965      | perl -0777 -pe                                                   \
966         's/^Copyright.+?Free\sSoftware\sFoundation,\sInc\.\n//ms'       \
967      | md5sum -                                                         \
968      | sed 's/ .*//')
969
970 # Ensure that we don't accidentally insert an entry into an old NEWS block.
971 sc_immutable_NEWS:
972         @if test -f $(srcdir)/NEWS; then                                \
973           test "$(NEWS_hash)" = '$(old_NEWS_hash)' && : ||              \
974             { echo '$(ME): you have modified old NEWS' 1>&2; exit 1; }; \
975         fi
976
977 # Update the hash stored above.  Do this after each release and
978 # for any corrections to old entries.
979 update-NEWS-hash: NEWS
980         perl -pi -e 's/^(old_NEWS_hash[ \t]+:?=[ \t]+).*/$${1}'"$(NEWS_hash)/" \
981           $(srcdir)/cfg.mk
982
983 # Ensure that we use only the standard $(VAR) notation,
984 # not @...@ in Makefile.am, now that we can rely on automake
985 # to emit a definition for each substituted variable.
986 # However, there is still one case in which @VAR@ use is not just
987 # legitimate, but actually required: when augmenting an automake-defined
988 # variable with a prefix.  For example, gettext uses this:
989 # MAKEINFO = env LANG= LC_MESSAGES= LC_ALL= LANGUAGE= @MAKEINFO@
990 # otherwise, makeinfo would put German or French (current locale)
991 # navigation hints in the otherwise-English documentation.
992 #
993 # Allow the package to add exceptions via a hook in cfg.mk;
994 # for example, @PRAGMA_SYSTEM_HEADER@ can be permitted by
995 # setting this to ' && !/PRAGMA_SYSTEM_HEADER/'.
996 _makefile_at_at_check_exceptions ?=
997 sc_makefile_at_at_check:
998         @perl -ne '/\@[A-Z_0-9]+\@/'                                    \
999           -e ' && !/([A-Z_0-9]+)\s+=.*\@\1\@$$/'                        \
1000           -e ''$(_makefile_at_at_check_exceptions)                      \
1001           -e 'and (print "$$ARGV:$$.: $$_"), $$m=1; END {exit !$$m}'    \
1002             $$($(VC_LIST_EXCEPT) | grep -E '(^|/)(Makefile\.am|[^/]+\.mk)$$') \
1003           && { echo '$(ME): use $$(...), not @...@' 1>&2; exit 1; } || :
1004
1005 news-check: NEWS
1006         if sed -n $(news-check-lines-spec)p $(srcdir)/NEWS              \
1007             | grep -E $(news-check-regexp) >/dev/null; then             \
1008           :;                                                            \
1009         else                                                            \
1010           echo 'NEWS: $$(news-check-regexp) failed to match' 1>&2;      \
1011           exit 1;                                                       \
1012         fi
1013
1014 sc_makefile_TAB_only_indentation:
1015         @prohibit='^    [ ]{8}'                                         \
1016         in_vc_files='akefile|\.mk$$'                                    \
1017         halt='found TAB-8-space indentation'                            \
1018           $(_sc_search_regexp)
1019
1020 sc_m4_quote_check:
1021         @prohibit='(AC_DEFINE(_UNQUOTED)?|AC_DEFUN)\([^[]'              \
1022         in_vc_files='(^configure\.ac|\.m4)$$'                           \
1023         halt='quote the first arg to AC_DEF*'                           \
1024           $(_sc_search_regexp)
1025
1026 fix_po_file_diag = \
1027 'you have changed the set of files with translatable diagnostics;\n\
1028 apply the above patch\n'
1029
1030 # Verify that all source files using _() are listed in po/POTFILES.in.
1031 po_file ?= $(srcdir)/po/POTFILES.in
1032 generated_files ?= $(srcdir)/lib/*.[ch]
1033 sc_po_check:
1034         @if test -f $(po_file); then                                    \
1035           grep -E -v '^(#|$$)' $(po_file)                               \
1036             | grep -v '^src/false\.c$$' | sort > $@-1;                  \
1037           files=;                                                       \
1038           for file in $$($(VC_LIST_EXCEPT)) $(generated_files); do      \
1039             test -r $$file || continue;                                 \
1040             case $$file in                                              \
1041               *.m4|*.mk) continue ;;                                    \
1042               *.?|*.??) ;;                                              \
1043               *) continue;;                                             \
1044             esac;                                                       \
1045             case $$file in                                              \
1046             *.[ch])                                                     \
1047               base=`expr " $$file" : ' \(.*\)\..'`;                     \
1048               { test -f $$base.l || test -f $$base.y; } && continue;;   \
1049             esac;                                                       \
1050             files="$$files $$file";                                     \
1051           done;                                                         \
1052           grep -E -l '\b(N?_|gettext *)\([^)"]*("|$$)' $$files          \
1053             | sed 's|^$(_dot_escaped_srcdir)/||' | sort -u > $@-2;      \
1054           diff -u -L $(po_file) -L $(po_file) $@-1 $@-2                 \
1055             || { printf '$(ME): '$(fix_po_file_diag) 1>&2; exit 1; };   \
1056           rm -f $@-1 $@-2;                                              \
1057         fi
1058
1059 # Sometimes it is useful to change the PATH environment variable
1060 # in Makefiles.  When doing so, it's better not to use the Unix-centric
1061 # path separator of `:', but rather the automake-provided `$(PATH_SEPARATOR)'.
1062 msg = '$(ME): Do not use `:'\'' above; use $$(PATH_SEPARATOR) instead'
1063 sc_makefile_path_separator_check:
1064         @prohibit='PATH[=].*:'                                          \
1065         in_vc_files='akefile|\.mk$$'                                    \
1066         halt=$(msg)                                                     \
1067           $(_sc_search_regexp)
1068
1069 # Check that `make alpha' will not fail at the end of the process.
1070 writable-files:
1071         if test -d $(release_archive_dir); then :; else                 \
1072           for file in $(distdir).tar.gz                                 \
1073                       $(release_archive_dir)/$(distdir).tar.gz; do      \
1074             test -e $$file || continue;                                 \
1075             test -w $$file                                              \
1076               || { echo ERROR: $$file is not writable; fail=1; };       \
1077           done;                                                         \
1078           test "$$fail" && exit 1 || : ;                                \
1079         fi
1080
1081 v_etc_file = $(gnulib_dir)/lib/version-etc.c
1082 sample-test = tests/sample-test
1083 texi = doc/$(PACKAGE).texi
1084 # Make sure that the copyright date in $(v_etc_file) is up to date.
1085 # Do the same for the $(sample-test) and the main doc/.texi file.
1086 sc_copyright_check:
1087         @require='enum { COPYRIGHT_YEAR = '$$(date +%Y)' };'            \
1088         in_files=$(v_etc_file)                                          \
1089         halt='out of date copyright in $(v_etc_file); update it'        \
1090           $(_sc_search_regexp)
1091         @require='# Copyright \(C\) '$$(date +%Y)' Free'                \
1092         in_vc_files=$(sample-test)                                      \
1093         halt='out of date copyright in $(sample-test); update it'       \
1094           $(_sc_search_regexp)
1095         @require='Copyright @copyright\{\} .*'$$(date +%Y)' Free'       \
1096         in_vc_files=$(texi)                                             \
1097         halt='out of date copyright in $(texi); update it'              \
1098           $(_sc_search_regexp)
1099
1100 # If tests/help-version exists and seems to be new enough, assume that its
1101 # use of init.sh and path_prepend_ is correct, and ensure that every other
1102 # use of init.sh is identical.
1103 # This is useful because help-version cross-checks prog --version
1104 # with $(VERSION), which verifies that its path_prepend_ invocation
1105 # sets PATH correctly.  This is an inexpensive way to ensure that
1106 # the other init.sh-using tests also get it right.
1107 _hv_file ?= $(srcdir)/tests/help-version
1108 _hv_regex_weak ?= ^ *\. .*/init\.sh"
1109 # Fix syntax-highlighters "
1110 _hv_regex_strong ?= ^ *\. "\$${srcdir=\.}/init\.sh"
1111 sc_cross_check_PATH_usage_in_tests:
1112         @if test -f $(_hv_file); then                                   \
1113           grep -l 'VERSION mismatch' $(_hv_file) >/dev/null             \
1114             || { echo "$@: skipped: no such file: $(_hv_file)" 1>&2;    \
1115                  exit 0; };                                             \
1116           grep -lE '$(_hv_regex_strong)' $(_hv_file) >/dev/null         \
1117             || { echo "$@: $(_hv_file) lacks conforming use of init.sh" 1>&2; \
1118                  exit 1; };                                             \
1119           good=$$(grep -E '$(_hv_regex_strong)' $(_hv_file));           \
1120           grep -LFx "$$good"                                            \
1121                 $$(grep -lE '$(_hv_regex_weak)' $$($(VC_LIST_EXCEPT)))  \
1122               | grep . &&                                               \
1123             { echo "$(ME): the above files use path_prepend_ inconsistently" \
1124                 1>&2; exit 1; } || :;                                   \
1125         fi
1126
1127 # #if HAVE_... will evaluate to false for any non numeric string.
1128 # That would be flagged by using -Wundef, however gnulib currently
1129 # tests many undefined macros, and so we can't enable that option.
1130 # So at least preclude common boolean strings as macro values.
1131 sc_Wundef_boolean:
1132         @prohibit='^#define.*(yes|no|true|false)$$'                     \
1133         in_files='$(CONFIG_INCLUDE)'                                    \
1134         halt='Use 0 or 1 for macro values'                              \
1135           $(_sc_search_regexp)
1136
1137 # Even if you use pathmax.h to guarantee that PATH_MAX is defined, it might
1138 # not be constant, or might overflow a stack.  In general, use PATH_MAX as
1139 # a limit, not an array or alloca size.
1140 sc_prohibit_path_max_allocation:
1141         @prohibit='(\balloca *\([^)]*|\[[^]]*)PATH_MAX'                 \
1142         halt='Avoid stack allocations of size PATH_MAX'                 \
1143           $(_sc_search_regexp)
1144
1145 sc_vulnerable_makefile_CVE-2009-4029:
1146         @prohibit='perm -777 -exec chmod a\+rwx|chmod 777 \$$\(distdir\)' \
1147         in_files=$$(find $(srcdir) -name Makefile.in)                   \
1148         halt=$$(printf '%s\n'                                           \
1149           'the above files are vulnerable; beware of running'           \
1150           '  "make dist*" rules, and upgrade to fixed automake'         \
1151           '  see http://bugzilla.redhat.com/542609 for details')        \
1152           $(_sc_search_regexp)
1153
1154 vc-diff-check:
1155         (unset CDPATH; cd $(srcdir) && $(VC) diff) > vc-diffs || :
1156         if test -s vc-diffs; then                               \
1157           cat vc-diffs;                                         \
1158           echo "Some files are locally modified:" 1>&2;         \
1159           exit 1;                                               \
1160         else                                                    \
1161           rm vc-diffs;                                          \
1162         fi
1163
1164 rel-files = $(DIST_ARCHIVES)
1165
1166 gnulib_dir ?= $(srcdir)/gnulib
1167 gnulib-version = $$(cd $(gnulib_dir) && git describe)
1168 bootstrap-tools ?= autoconf,automake,gnulib
1169
1170 # If it's not already specified, derive the GPG key ID from
1171 # the signed tag we've just applied to mark this release.
1172 gpg_key_ID ?= \
1173   $$(git cat-file tag v$(VERSION) > .ann-sig \
1174      && gpgv .ann-sig - < /dev/null 2>&1 \
1175           | sed -n '/.*key ID \([0-9A-F]*\)/s//\1/p'; rm -f .ann-sig)
1176
1177 translation_project_ ?= coordinator@translationproject.org
1178
1179 # Make info-gnu the default only for a stable release.
1180 ifeq ($(RELEASE_TYPE),stable)
1181   announcement_Cc_ ?= $(translation_project_), $(PACKAGE_BUGREPORT)
1182   announcement_mail_headers_ ?=                                         \
1183     To: info-gnu@gnu.org                                                \
1184     Cc: $(announcement_Cc_)                                             \
1185     Mail-Followup-To: $(PACKAGE_BUGREPORT)
1186 else
1187   announcement_Cc_ ?= $(translation_project_)
1188   announcement_mail_headers_ ?=                                         \
1189     To: $(PACKAGE_BUGREPORT)                                            \
1190     Cc: $(announcement_Cc_)
1191 endif
1192
1193 announcement: NEWS ChangeLog $(rel-files)
1194         @$(build_aux)/announce-gen                                      \
1195             --mail-headers='$(announcement_mail_headers_)'              \
1196             --release-type=$(RELEASE_TYPE)                              \
1197             --package=$(PACKAGE)                                        \
1198             --prev=$(PREV_VERSION)                                      \
1199             --curr=$(VERSION)                                           \
1200             --gpg-key-id=$(gpg_key_ID)                                  \
1201             --news=$(srcdir)/NEWS                                       \
1202             --bootstrap-tools=$(bootstrap-tools)                        \
1203             --gnulib-version=$(gnulib-version)                          \
1204             --no-print-checksums                                        \
1205             $(addprefix --url-dir=, $(url_dir_list))
1206
1207 ## ---------------- ##
1208 ## Updating files.  ##
1209 ## ---------------- ##
1210
1211 ftp-gnu = ftp://ftp.gnu.org/gnu
1212 www-gnu = http://www.gnu.org
1213
1214 upload_dest_dir_ ?= $(PACKAGE)
1215 emit_upload_commands:
1216         @echo =====================================
1217         @echo =====================================
1218         @echo "$(build_aux)/gnupload $(GNUPLOADFLAGS) \\"
1219         @echo "    --to $(gnu_rel_host):$(upload_dest_dir_) \\"
1220         @echo "  $(rel-files)"
1221         @echo '# send the ~/announce-$(my_distdir) e-mail'
1222         @echo =====================================
1223         @echo =====================================
1224
1225 define emit-commit-log
1226   printf '%s\n' 'post-release administrivia' '' \
1227     '* NEWS: Add header line for next release.' \
1228     '* .prev-version: Record previous version.' \
1229     '* cfg.mk (old_NEWS_hash): Auto-update.'
1230 endef
1231
1232 .PHONY: no-submodule-changes
1233 no-submodule-changes:
1234         if test -d $(srcdir)/.git; then                                 \
1235           diff=$$(cd $(srcdir) && git submodule -q foreach              \
1236                   git diff-index --name-only HEAD)                      \
1237             || exit 1;                                                  \
1238           case $$diff in '') ;;                                         \
1239             *) echo '$(ME): submodule files are locally modified:';     \
1240                 echo "$$diff"; exit 1;; esac;                           \
1241         else                                                            \
1242           : ;                                                           \
1243         fi
1244
1245 submodule-checks ?= no-submodule-changes public-submodule-commit
1246
1247 # Ensure that each sub-module commit we're using is public.
1248 # Without this, it is too easy to tag and release code that
1249 # cannot be built from a fresh clone.
1250 .PHONY: public-submodule-commit
1251 public-submodule-commit:
1252         $(AM_V_GEN)if test -d $(srcdir)/.git; then                      \
1253           cd $(srcdir) &&                                               \
1254           git submodule --quiet foreach test '$$(git rev-parse $$sha1)' \
1255               = '$$(git merge-base origin $$sha1)'                      \
1256             || { echo '$(ME): found non-public submodule commit' >&2;   \
1257                  exit 1; };                                             \
1258         else                                                            \
1259           : ;                                                           \
1260         fi
1261 # This rule has a high enough utility/cost ratio that it should be a
1262 # dependent of "check" by default.  However, some of us do occasionally
1263 # commit a temporary change that deliberately points to a non-public
1264 # submodule commit, and want to be able to use rules like "make check".
1265 # In that case, run e.g., "make check gl_public_submodule_commit="
1266 # to disable this test.
1267 gl_public_submodule_commit ?= public-submodule-commit
1268 check: $(gl_public_submodule_commit)
1269
1270 .PHONY: alpha beta stable
1271 ALL_RECURSIVE_TARGETS += alpha beta stable
1272 alpha beta stable: $(local-check) writable-files $(submodule-checks)
1273         test $@ = stable                                                \
1274           && { echo $(VERSION) | grep -E '^[0-9]+(\.[0-9]+)+$$'         \
1275                || { echo "invalid version string: $(VERSION)" 1>&2; exit 1;};}\
1276           || :
1277         $(MAKE) vc-diff-check
1278         $(MAKE) news-check
1279         $(MAKE) distcheck
1280         $(MAKE) dist XZ_OPT=-9ev
1281         $(MAKE) $(release-prep-hook) RELEASE_TYPE=$@
1282         $(MAKE) -s emit_upload_commands RELEASE_TYPE=$@
1283
1284 # Override this in cfg.mk if you follow different procedures.
1285 release-prep-hook ?= release-prep
1286
1287 gl_noteworthy_news_ = * Noteworthy changes in release ?.? (????-??-??) [?]
1288 .PHONY: release-prep
1289 release-prep:
1290         case $$RELEASE_TYPE in alpha|beta|stable) ;; \
1291           *) echo "invalid RELEASE_TYPE: $$RELEASE_TYPE" 1>&2; exit 1;; esac
1292         $(MAKE) --no-print-directory -s announcement > ~/announce-$(my_distdir)
1293         if test -d $(release_archive_dir); then                 \
1294           ln $(rel-files) $(release_archive_dir);               \
1295           chmod a-w $(rel-files);                               \
1296         fi
1297         echo $(VERSION) > $(prev_version_file)
1298         $(MAKE) update-NEWS-hash
1299         perl -pi -e '$$. == 3 and print "$(gl_noteworthy_news_)\n\n\n"' NEWS
1300         $(emit-commit-log) > .ci-msg
1301         $(VC) commit -F .ci-msg -a
1302         rm .ci-msg
1303
1304 # Override this with e.g., -s $(srcdir)/some_other_name.texi
1305 # if the default $(PACKAGE)-derived name doesn't apply.
1306 gendocs_options_ ?=
1307
1308 .PHONY: web-manual
1309 web-manual:
1310         @test -z "$(manual_title)" \
1311           && { echo define manual_title in cfg.mk 1>&2; exit 1; } || :
1312         @cd '$(srcdir)/doc'; \
1313           $(SHELL) ../build-aux/gendocs.sh $(gendocs_options_) \
1314              -o '$(abs_builddir)/doc/manual' \
1315              --email $(PACKAGE_BUGREPORT) $(PACKAGE) \
1316             "$(PACKAGE_NAME) - $(manual_title)"
1317         @echo " *** Upload the doc/manual directory to web-cvs."
1318
1319 # Code Coverage
1320
1321 init-coverage:
1322         $(MAKE) $(AM_MAKEFLAGS) clean
1323         lcov --directory . --zerocounters
1324
1325 COVERAGE_CCOPTS ?= "-g --coverage"
1326 COVERAGE_OUT ?= doc/coverage
1327
1328 build-coverage:
1329         $(MAKE) $(AM_MAKEFLAGS) CFLAGS=$(COVERAGE_CCOPTS) CXXFLAGS=$(COVERAGE_CCOPTS)
1330         $(MAKE) $(AM_MAKEFLAGS) CFLAGS=$(COVERAGE_CCOPTS) CXXFLAGS=$(COVERAGE_CCOPTS) check
1331         mkdir -p $(COVERAGE_OUT)
1332         lcov --directory . --output-file $(COVERAGE_OUT)/$(PACKAGE).info \
1333                 --capture
1334
1335 gen-coverage:
1336         genhtml --output-directory $(COVERAGE_OUT) \
1337                 $(COVERAGE_OUT)/$(PACKAGE).info \
1338                 --highlight --frames --legend \
1339                 --title "$(PACKAGE_NAME)"
1340
1341 coverage: init-coverage build-coverage gen-coverage
1342
1343 # Update gettext files.
1344 PACKAGE ?= $(shell basename $(PWD))
1345 PO_DOMAIN ?= $(PACKAGE)
1346 POURL = http://translationproject.org/latest/$(PO_DOMAIN)/
1347 PODIR ?= po
1348 refresh-po:
1349         rm -f $(PODIR)/*.po && \
1350         echo "$(ME): getting translations into po (please ignore the robots.txt ERROR 404)..." && \
1351         wget --no-verbose --directory-prefix $(PODIR) --no-directories --recursive --level 1 --accept .po --accept .po.1 $(POURL) && \
1352         echo 'en@boldquot' > $(PODIR)/LINGUAS && \
1353         echo 'en@quot' >> $(PODIR)/LINGUAS && \
1354         ls $(PODIR)/*.po | sed 's/\.po//' | sed 's,$(PODIR)/,,' | sort >> $(PODIR)/LINGUAS
1355
1356  # Running indent once is not idempotent, but running it twice is.
1357 INDENT_SOURCES ?= $(C_SOURCES)
1358 .PHONY: indent
1359 indent:
1360         indent $(INDENT_SOURCES)
1361         indent $(INDENT_SOURCES)
1362
1363 # If you want to set UPDATE_COPYRIGHT_* environment variables,
1364 # put the assignments in this variable.
1365 update-copyright-env ?=
1366
1367 # Run this rule once per year (usually early in January)
1368 # to update all FSF copyright year lists in your project.
1369 # If you have an additional project-specific rule,
1370 # add it in cfg.mk along with a line 'update-copyright: prereq'.
1371 # By default, exclude all variants of COPYING; you can also
1372 # add exemptions (such as ChangeLog..* for rotated change logs)
1373 # in the file .x-update-copyright.
1374 .PHONY: update-copyright
1375 update-copyright:
1376         grep -l -w Copyright                                             \
1377           $$(export VC_LIST_EXCEPT_DEFAULT=COPYING && $(VC_LIST_EXCEPT)) \
1378           | $(update-copyright-env) xargs $(build_aux)/$@
1379
1380 # This tight_scope test is skipped with a warning if $(_gl_TS_headers) is not
1381 # overridden and $(_gl_TS_dir)/Makefile.am does not mention noinst_HEADERS.
1382
1383 # NOTE: to override any _gl_TS_* default value, you must
1384 # define the variable(s) using "export" in cfg.mk.
1385 _gl_TS_dir ?= src
1386
1387 ALL_RECURSIVE_TARGETS += sc_tight_scope
1388 sc_tight_scope: tight-scope.mk
1389         @if ! grep '^ *export _gl_TS_headers *=' $(srcdir)/cfg.mk       \
1390                 > /dev/null                                             \
1391            && ! grep -w noinst_HEADERS $(srcdir)/$(_gl_TS_dir)/Makefile.am \
1392                 > /dev/null 2>&1; then                                  \
1393             echo '$(ME): skipping $@';                                  \
1394         else                                                            \
1395             $(MAKE) -s -C $(_gl_TS_dir)                                 \
1396                 -f Makefile                                             \
1397                 -f $(abs_top_srcdir)/cfg.mk                             \
1398                 -f $(abs_top_builddir)/$<                               \
1399               _gl_tight_scope                                           \
1400                 || fail=1;                                              \
1401         fi
1402         @rm -f $<
1403
1404 tight-scope.mk: $(ME)
1405         @rm -f $@ $@-t
1406         @perl -ne '/^# TS-start/.../^# TS-end/ and print' $(ME) > $@-t
1407         @chmod a=r $@-t && mv $@-t $@
1408
1409 ifeq (a,b)
1410 # TS-start
1411
1412 # Most functions should have static scope.
1413 # Any that don't must be marked with `extern', but `main'
1414 # and `usage' are exceptions: they're always extern, but
1415 # do not need to be marked.  Symbols matching `__.*' are
1416 # reserved by the compiler, so are automatically excluded below.
1417 _gl_TS_unmarked_extern_functions ?= main usage
1418 _gl_TS_function_match ?= /^(?:$(_gl_TS_extern)) +.*?(\S+) +\(/
1419
1420 # If your project uses a macro like "XTERN", then put
1421 # the following in cfg.mk to override this default:
1422 # export _gl_TS_extern = extern|XTERN
1423 _gl_TS_extern ?= extern
1424
1425 # The second nm|grep checks for file-scope variables with `extern' scope.
1426 # Without gnulib's progname module, you might put program_name here.
1427 # Symbols matching `__.*' are reserved by the compiler,
1428 # so are automatically excluded below.
1429 _gl_TS_unmarked_extern_vars ?=
1430
1431 # NOTE: the _match variables are perl expressions -- not mere regular
1432 # expressions -- so that you can extend them to match other patterns
1433 # and easily extract matched variable names.
1434 # For example, if your project declares some global variables via
1435 # a macro like this: GLOBAL(type, var_name, initializer), then you
1436 # can override this definition to automatically extract those names:
1437 # export _gl_TS_var_match = \
1438 #   /^(?:$(_gl_TS_extern)) .*?\**(\w+)(\[.*?\])?;/ || /\bGLOBAL\(.*?,\s*(.*?),/
1439 _gl_TS_var_match ?= /^(?:$(_gl_TS_extern)) .*?(\w+)(\[.*?\])?;/
1440
1441 # The names of object files in (or relative to) $(_gl_TS_dir).
1442 _gl_TS_obj_files ?= *.$(OBJEXT)
1443
1444 # Files in which to search for the one-line style extern declarations.
1445 # $(_gl_TS_dir)-relative.
1446 _gl_TS_headers ?= $(noinst_HEADERS)
1447
1448 .PHONY: _gl_tight_scope
1449 _gl_tight_scope: $(bin_PROGRAMS)
1450         t=exceptions-$$$$;                                              \
1451         trap 's=$$?; rm -f $$t; exit $$s' 0;                            \
1452         for sig in 1 2 3 13 15; do                                      \
1453           eval "trap 'v=`expr $$sig + 128`; (exit $$v); exit $$v' $$sig"; \
1454         done;                                                           \
1455         src=`for f in $(SOURCES); do                                    \
1456                test -f $$f && d= || d=$(srcdir)/; echo $$d$$f; done`;   \
1457         hdr=`for f in $(_gl_TS_headers); do                             \
1458                test -f $$f && d= || d=$(srcdir)/; echo $$d$$f; done`;   \
1459         ( printf '^%s$$\n' '__.*' $(_gl_TS_unmarked_extern_functions);  \
1460           grep -h -A1 '^extern .*[^;]$$' $$src                          \
1461             | grep -vE '^(extern |--)' | sed 's/ .*//';                 \
1462           perl -lne                                                     \
1463              '$(_gl_TS_function_match) and print "^$$1\$$"' $$hdr;      \
1464         ) | sort -u > $$t;                                              \
1465         nm -e $(_gl_TS_obj_files) | sed -n 's/.* T //p'|grep -Ev -f $$t \
1466           && { echo the above functions should have static scope >&2;   \
1467                exit 1; } || : ;                                         \
1468         ( printf '^%s$$\n' '__.*' $(_gl_TS_unmarked_extern_vars);       \
1469           perl -lne '$(_gl_TS_var_match) and print "^$$1\$$"' $$hdr *.h \
1470         ) | sort -u > $$t;                                              \
1471         nm -e $(_gl_TS_obj_files) | sed -n 's/.* [BCDGRS] //p'          \
1472             | sort -u | grep -Ev -f $$t                                 \
1473           && { echo the above variables should have static scope >&2;   \
1474                exit 1; } || :
1475 # TS-end
1476 endif